<?php

set_include_path(implode(PATH_SEPARATOR, array(
	dirname(__FILE__) . '/system/classes/dbtables',
	dirname(__FILE__) . '/system/classes/mappers',
	dirname(__FILE__) . '/system/classes/models',
    get_include_path()
)));

class Youtubeupload extends Tools_Plugins_Abstract {

	private $_pageUrl = null;

    const YOUTUBEUPLOAD_SECURE_TOKEN = 'YoutubeuploadToken';
    
	public function  __construct($options, $seotoasterData) {
		parent::__construct($options, $seotoasterData);

        $this->_layout = new Zend_Layout();
        $this->_layout->setLayoutPath(Zend_Layout::getMvcInstance()->getLayoutPath());

        if(($scriptPaths = Zend_Layout::getMvcInstance()->getView()->getScriptPaths()) !== false) {
            $this->_view->setScriptPath($scriptPaths);
        }
        $this->_view->addScriptPath(__DIR__ . '/views/');
               
    }
    public function beforeController(){
        $token = $this->_request->getParam('token');
        if($token != null){
           $this->_sessionHelper->sessionToken = Zend_Gdata_AuthSub::getAuthSubSessionToken($token);
           if(isset($this->_sessionHelper->urlSiteUtube)){
              $url = $this->_sessionHelper->urlSiteUtube;
              unset($this->_sessionHelper->urlSiteUtube);
              $this->_redirector->gotoUrl($url);
           }
        }
    }
    
	public function run($requestedParams = array()) {
		$this->_requestedParams = $requestedParams;
		    $dispatchersResult      = parent::run($requestedParams);
            $yt = new Zend_Gdata_YouTube();
            $this->_view->translator = $this->_translator;
            $this->_pageUrl = $this->_seotoasterData['websiteUrl'].$this->_seotoasterData['url']; 
            $this->_sessionHelper->urlSiteUtube = $this->_pageUrl;
            $this->_view->websiteUrl = $this->_websiteUrl;
            if (!isset($this->_sessionHelper->sessionToken)){
                $this->_view->authSubRequestUrl = $this->_getAuthSubRequestUrl($this->_websiteUrl);
                return $this->_view->render("upload.phtml");
            }
            $this->_view->pageUrl = $this->_pageUrl;
            $this->_sessionHelper->httpClient = Zend_Gdata_AuthSub::getHttpClient($this->_sessionHelper->sessionToken);
            $this->_sessionHelper->tags = $this->_options[0];
            $this->_sessionHelper->category = $this->_options[1];
            return $this->_view->render("prepareUpload.phtml");
			              
    }
	protected function _makeOptionName() {
		
	}
    public function authYoutubeAction() {
        $token = $this->_request->getParam('token');
        $url = $this->_sessionHelper->urlSiteUtube;
        $this->_sessionHelper->sessionToken = Zend_Gdata_AuthSub::getAuthSubSessionToken($token);
        $this->_redirector->gotoUrl($url);
    }
    private  function _getAuthSubRequestUrl($next) {
        $scope = 'http://gdata.youtube.com';
        $secure = false;
        $session = true;
        $requestUri = 'https://accounts.google.com/AuthSubRequest';
        $queryString ='?scope=' . urldecode($scope)
                    . '&secure=' . urlencode($secure)
                    . '&session=' . urlencode($session)
                    . '&next=' . urlencode($next);
        return $requestUri . $queryString;
    }
    public function uploadFormAction(){
        $status = $this->_request->getParam('status');
        $id = $this->_request->getParam('id');
        if ($status == 200){
            $this->_view->success = $status;
        }
        $this->_view->translator = $this->_translator;
        $this->_view->pageUrl= $this->_request->getParam('pageUrl');

        $this->_layout->content = $this->_view->render('youtubeForm.phtml');
        echo $this->_layout->render();
    }
    public function youtubeFormAction(){
        $nextUrl = $this->_request->getParam('pageUrl');
        $protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== '' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
        $youtubeTitle = htmlspecialchars(trim($this->_request->getParam('youtubeTitle')));
        $youtubeDescription = htmlspecialchars(trim($this->_request->getParam('youtubeDescription')));
        $mapper = YoutubeuploadMapper::getInstance();
        $developerKey = $mapper->selectApikey();
        $applicationId = '';
        $clientId = '';
        $yt = new Zend_Gdata_YouTube($this->_sessionHelper->httpClient, $applicationId, $clientId, $developerKey);
        $myVideoEntry = new Zend_Gdata_YouTube_VideoEntry();
        $myVideoEntry->setVideoTitle($youtubeTitle);
        $myVideoEntry->setVideoDescription($youtubeDescription);
        // The category must be a valid YouTube category!
        $myVideoEntry->setVideoCategory($this->_sessionHelper->category);
        // Set keywords. Please note that this must be a comma-separated string
        // and that individual keywords cannot contain whitespace
        $myVideoEntry->SetVideoTags($this->_sessionHelper->tags);
        $tokenHandlerUrl = $protocol . 'gdata.youtube.com/action/GetUploadToken';
        $tokenArray = $yt->getFormUploadToken($myVideoEntry, $tokenHandlerUrl);
        $tokenValue = $tokenArray['token'];
        $postUrl = $tokenArray['url'];
        echo $form = '<form id="youtubeUpload" class="content-auto h200px pt50px pb50px" action="'. $postUrl .'?nexturl='. $this->_websiteUrl .'/plugin/youtubeupload/run/uploadForm/'.
                          '" method="post" enctype="multipart/form-data">'.
                          '<p class="grid_8">'.
                          '<input id="uploadFile" class="grid_8 alpha omega" placeholder="Choose File" disabled="disabled" />'.
                          '<label class="btn-upload btn grid_4 alpha omega" for="Video">'.$this->_translator->translate('Choose File').'</label><input id="Video" name="file" type="file" class="hidden">'.
                          '</p>'.
                          '<button id="submitVideo" class="btn grid_4 mt0px success" type="submit">' . $this->_translator->translate('Upload Video File') . '</button>'.
                        '<input name="token" type="hidden" value="'. $tokenValue .'"/>'.
            '</form>';
    }
    public function youtubeConfigAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)){
            $mapper = YoutubeuploadMapper::getInstance();
            $this->_view->translator = $this->_translator;
            $this->_view->youtubeApikey = $mapper->selectApikey();
            $this->_layout->content = $this->_view->render('config.phtml');
            echo $this->_layout->render();
        }
    }
    public function saveConfigAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)){
            $mapper = YoutubeuploadMapper::getInstance();
            $model  = new YoutubeuploadModel();
            $youtubeApiKey = trim($this->_request->getParam('youtubeApiKey'));
            $secureToken = $this->_request->getParam(Tools_System_Tools::CSRF_SECURE_TOKEN, false);
            $tokenValid = Tools_System_Tools::validateToken($secureToken, self::YOUTUBEUPLOAD_SECURE_TOKEN);
            if (!$tokenValid) {
                $this->_responseHelper->fail('');
            }
            $model->setValue($youtubeApiKey);
            $mapper->save($model);
        }
    }
    
}

